      SUBROUTINE ALS1R(A,U,F,M,N,EPS,H,W,L)
      REAL A(M,N),U(N),F(M),H(7),W(N,5)
      RMIN1=1.
      GO TO (1,3,2),L
    1 RMIN=RMIN1
      RMIN1=RMIN/2.
      IF(RMIN1.GT.0.) GO TO 1
      CALL ALS1R1(A,M,N,W,W(1,2))
      W(N,2)=RMIN
    2 CALL ALS1R2(A,M,N,F)
    3 RMIN=W(N,2)
      RMIN1=16*RMIN
      F1=F(1)
      R=F1*F1
      DO 4 I=2,N
      F1=F(I)
    4 R=R+F1*F1
      SR=SQRT(R)
      S=(F(1)*W(1,1)/SR)**2
      DO 5 I=2,N
      F1=F(I)
    5 S=S+((W(I,1)*F1+W(I-1,2)*F(I-1))/SR)**2
      RR=SR*EPS
      H(1)=SR
      H(2)=0.
      H(3)=0.
      H(4)=R
      H(5)=1.E+20
      H(6)=1.
      H(7)=0.
      NITER=0
      NIT=0
      IEXIT=-1
      HH=SR
      QQ=H(5)
      DO 6 I=1,N
    6 U(I)=0.
      IF(EPS.GE.1.) RETURN
      Q=(EPS/(1.-EPS))*S
      IF(Q.EQ.0.) Q=RMIN
    7 CONTINUE
      CALL ALS1R3(W,W(1,2),M,N,Q,F,U,H,W(1,3),W(1,4),W(1,5))
      H1=H(1)
      NITER=NITER+1
      IF(IEXIT.EQ.1) GO TO 10
      IF(HH.GE.H1) GO TO 8
      IEXIT=1
      Q=QQ
      GO TO 7
    8 IF(RR*1.001.GE.H1) GO TO 10
      IF(Q.LE.RMIN1) GO TO 10
      HH=H1
      QQ=Q
      S=0.
      DO 9 I=1,N
    9 S=S+U(I)*Q*W(I,5)
      IF(S.EQ.0.) S=4.*RMIN1
      R=(H1/RR-1.)*H1*(H1/S)
      IF(R.LE.0.5) NIT=NIT+1
      IF(R.LE.0.5.AND.H(6).GE.10..AND.NIT.GT.5) R=1.
      Q=Q/(1.+R)
      IF(Q.EQ.0.) Q=RMIN
      GO TO 7
   10 CALL ALS1R4(A,M,N,U)
      H(7)=NITER
      W(N,2)=RMIN
      RETURN
      END
