      SUBROUTINE ALS1R1(A,M,N,B,C)
C****************************************************C
C       :                  C
C              D(M,N)=Q(M,M)*A(M,N)*R(N,N)           C
C     Q=QN*..*Q1  R=R1*..*RN- . C
C     D-   .           C
C****************************************************C
      INTEGER M,N,I,J,K,L,II,JJ,JN,I1,J1,ISWTCH
      REAL A,B,C,H,R1,R2,R3,R4,R5,R6
      REAL ZERO,ONE,TWO,SUM,RMIN,RNORM
      DOUBLE PRECISION RD,RD2,DZERO,DS1,DS2,DMIN
      DIMENSION A(M,N),B(N),C(N)
      DATA ZERO,DZERO,ONE,TWO/0.,0.0D0,1.,2./
      RNORM=ZERO
      IF(M.LT.N.OR.N.LE.2) GO TO 62
      RMIN=ONE
   10 RMIN=RMIN/TWO
      IF(ONE.LT.(ONE+RMIN).AND.RMIN.GT.ZERO) GO TO 10
      DMIN=DBLE(RMIN)**2
      DS1=DZERO
      DS2=DZERO
      SUM=ZERO
      ISWTCH=1
      R5=ZERO
      DO 11 I=1,M
      DO 11 J=1,N
      R6=ABS(A(I,J))
      IF(R6.GT.R5) R5=R6
   11 CONTINUE
      RNORM=ONE
      IF(R5.EQ.ZERO) RETURN
      IF(((R5*RMIN)/128.)*128.*RMIN.GT.ZERO) GO TO 13
      IF(R5.GT.ONE) GO TO 13
      IF((R5/128.).EQ.ZERO) R5=R5*128.
      ISWTCH=(INT(-ALOG(R5)/ALOG(TWO))+1)/2
      RNORM=TWO**ISWTCH
      DO 12 I=1,M
      DO 12 J=1,N
      A(I,J)=(A(I,J)*RNORM)*RNORM
   12 CONTINUE
   13 JJ=1
      JN=2
      C(N)=ZERO
   20 RD2=DZERO
      DO 21 K=JJ,M
      RD=A(K,JJ)
   21 RD2=RD2+RD*RD
   22 R2=RD2
      DS1=DS1+RD2
      DS2=DS2-RD2
      J=JJ
      JJ=JN
      JN=JJ+1
      IF(DS2.LT.DMIN*DS1.AND.ISWTCH.LT.0) GO TO 60
      R4=DS1
      R4=(RMIN*R4)*RMIN
      IF(R2.GT.R4.OR.ISWTCH.LT.0) GO TO 24
      SUM=R2
      DO 23 I1=J,M
      DO 23 J1=JJ,N
   23 SUM=SUM+A(I1,J1)**2
      DS2=SUM
      ISWTCH=-1
      IF(DS2.LE.DMIN*DS1) GO TO 60
   24 R1=A(J,J)
      R3=SIGN(SQRT(R2),R1)
      B(J)=-R3
      L=JJ-N
      IF(R2) 62,41,25
   25 R1=SQRT(ONE+R1/R3)
      R2=ONE/(R3*R1)
      A(J,J)=R1
      DO 26 I=JJ,M
   26 A(I,J)=A(I,J)*R2
      IF(L) 27,27,62
   27 RD2=DZERO
      DO 29 K=JJ,N
      R3=ZERO
      DO 28 I=J,M
   28 R3=R3+A(I,J)*A(I,K)
      R2=A(J,K)-R1*R3
      A(J,K)=R2
      RD=R2
      RD2=RD2+RD*R2
      DO 29 I=JJ,M
   29 A(I,K)=A(I,K)-R3*A(I,J)
   40 IF(L) 46,43,62
   41 DO 42 II=J,M
   42 A(II,J)=ZERO
      IF(L) 44,43,62
   43 R3=A(N-1,N)
      R4=DS1
      R4=(RMIN*R4)*RMIN
      R3=R3*R3
      IF(R3.LE.R4.AND.M.LE.N) A(N-1,N)=ZERO
      R3=A(N,N)
      R3=R3*R3
      IF(R3.LE.R4.AND.M.LE.N) A(N,N)=ZERO
      C(N-1)=A(N-1,N)
      B(N)=A(N,N)
      IF(M-N) 62,62,20
   44 RD2=DZERO
      DO 45 K=JJ,N
      RD=A(J,K)
   45 RD2=RD2+RD*RD
   46 R2=RD2
      DS1=DS1+RD2
      DS2=DS2-RD2
      R1=A(J,JJ)
      R3=SIGN(SQRT(R2),R1)
      C(J)=-R3
      IF(R2) 62,47,49
   47 DO 48 II=JJ,N
   48 A(J,II)=ZERO
      GO TO 20
   49 R1=SQRT(ONE+R1/R3)
      R2=ONE/(R3*R1)
      A(J,JJ)=R1
      DO 50 K=JN,N
   50 A(J,K)=A(J,K)*R2
      RD2=DZERO
      DO 52 I=JJ,M
      R3=ZERO
      DO 51 K=JJ,N
   51 R3=R3+A(J,K)*A(I,K)
      R2=A(I,JJ)-R1*R3
      A(I,JJ)=R2
      RD=R2
      RD2=RD2+RD*R2
      DO 52 K=JN,N
   52 A(I,K)=A(I,K)-R3*A(J,K)
      GO TO 22
   60 DO 61 J1=J,N
      B(J1)=ZERO
      C(J1)=ZERO
      DO 61 I1=J,M
   61 A(I1,J1)=ZERO
   62 IF(RNORM.EQ.ONE) GO TO 70
      RNORM=ONE/RNORM
      DO 63 J=1,N
      B(J)=(B(J)*RNORM)*RNORM
      C(J)=(C(J)*RNORM)*RNORM
   63 CONTINUE
   70 RETURN
      END
