      SUBROUTINE ALS1R3(B,C,M,N,Q,F,U,H,V,W,W1)
C****************************************************C
C        (D'*D+Q*E)*U=D'*F            C
C        .      C
C****************************************************C
      INTEGER I,J,K,L,L1,M,N
      REAL B,C,Q,F,U,H,V,W,W1,R,R1,R2,T,T1,T2
      REAL S,S1,S2,S3,S5,ZERO
      DIMENSION B(N),C(N),U(N),V(N),W(N),W1(N),F(M),H(7)
      DATA ZERO/0./
      IF(M.LT.N.OR.N.LE.2.OR.Q.LT.ZERO) RETURN
      S=ZERO
      L=N+1
   10 L=L-1
      R=C(L-1)
      IF(B(L).EQ.S.AND.R.EQ.S.AND.L.GT.3) GO TO 10
      L1=L+1
      IF(L-M) 11,13,20
   11 DO 12 I=L1,M
      T1=F(I)
   12 S=S+T1*T1
   13 T=B(1)
      R=AMAX1(SQRT(Q+T*T),ABS(T))
      V(1)=R
      T2=C(1)
      R2=T2*(T/R)
      W(1)=R2
      S2=F(1)
      R1=T*S2/R
      U(1)=R1
      S5=S2*S2
      DO 14 I=2,L
      T=B(I)
      T1=T2
      T2=C(I)
      S1=S2
      S2=F(I)
      R=AMAX1(ZERO,(T1-R2)*(T1+R2))
      R=AMAX1(SQRT(T*T+R+Q),ABS(T))
      R1=(T*S2+T1*S1-R1*R2)/R
      U(I)=R1
      V(I)=R
      R2=T2*(T/R)
      W(I)=R2
   14 S5=S5+S2*S2
      R2=SQRT(Q)
      IF(L1.GT.N) GO TO 16
      DO 15 I=L1,N
      U(I)=ZERO
      V(I)=R2
      W(I)=ZERO
   15 W1(I)=ZERO
   16 R=R1/R
      U(L)=R
      R2=R*T-S2
      S1=R2*R2
      S3=R*R
      DO 17 I=2,L
      J=L1-I
      R1=R
      R=(U(J)-R*W(J))/V(J)
      U(J)=R
      R2=R*B(J)+R1*C(J)
      R2=R2-F(J)
      S1=S1+R2*R2
   17 S3=S3+R*R
      R=Q*R/V(1)
      W1(1)=R
      DO 18 K=2,L
      R=(Q*U(K)-R*W(K-1))/V(K)
   18 W1(K)=R
      R=R/V(L)
      W1(L)=R
      S2=R*R
      DO 19 I=2,L
      J=L1-I
      R=(W1(J)-R*W(J))/V(J)
      W1(J)=R
      S2=S2+R*R
      R1=(W1(J+1)+U(J+1))*W(J)
   19 CONTINUE
C----------------------------------------------------C
C        :      C
C      H(1)  = !!D*U-F!!   -   .              C
C      H(2)  = Q*!!!U'!!!  -   .     C
C      H(3)  = !!!U!!!     -   . .    C
C      H(4)  = !!D*U-F!!**2+Q*!!!U!!!**2             C
C      H(5)  = Q      -    .    C
C      H(6)  = !!D*U-F!!/!!F!! -  .    C
C----------------------------------------------------C
      H(1)=SQRT(S1+S)
      H(2)=SQRT(S2)
      H(3)=SQRT(S3)
      H(4)=S1+S+Q*S3
      H(5)=Q
      H(6)=H(1)/SQRT(S5+S)
   20 RETURN
      END
